##### WORKFLOW #####
workflow:
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
      when: always
    - if: $CI_PIPELINE_SOURCE == "schedule"
      when: always
    - if: $CI_PIPELINE_SOURCE == "web"
      when: always
    - when: never

stages:
  - test

# PHP 8.3 (Main version with coverage)
test:phpunit-8.3:
  extends: .test:phpunit
  image: uranus01.swmcloud.net/openxtrem/ox-platform/php8.3-fpm:1.1.1
  variables:
    XDEBUG_MODE: "coverage"
  coverage: '/^\s+Lines:\s+([\d\.]+)/'
  artifacts:
    paths:
      - .phpunit/coverage.xml
      - .phpunit/html_coverage
    when: always
    expire_in: 1 month
    reports:
      junit: .phpunit/junit.xml

# PHP 8.2 (Compatibility)
test:phpunit-8.2:
  extends: .test:phpunit
  image: uranus01.swmcloud.net/openxtrem/ox-platform/php8.2-fpm:1.2.3
  variables:
    XDEBUG_MODE: "off"

# Test job template
.test:phpunit:
  stage: test
  services:
    - name: "clamav/clamav:stable"
      alias: clamav
  variables:
    CLAMAV_HOST: 'clamav'
    CLAMAV_PORT: 3310
  before_script:
    - XDEBUG_MODE=off composer validate --no-check-all --strict
    - XDEBUG_MODE=off composer install --optimize-autoloader
  tags:
    - S
  script:
    - vendor/bin/phpunit